///////////////////////////////////////////////////////////////////////////////////////////
// SearchFile.  main entry module for program
// V1 
//
// Thisis a Win GUI program to search recursively in a specified drive & path for all files
// meeting the spec given by user.
//
//
////////////////////////////
#include "SRCHFILE.h"
#include <process.h>  //for _execl()

/*
**  Defines
*/
#define IDD_GETGOING 200
#define IDD_GETVARS  201
#define IDD_SET_DEFAULTS 202
#define IDD_SET_WAITING_FACE  400
#define IDD_SET_INIT_FACE	401
#define IDM_ABOUT 1
#define PROGRESS_GRANULARITY 1000L


static char *version= "1.0";

#define MAX_SR_STRING  5000
static char szUserPath[MAX_PATH+200];
static char szUserType[MAX_PATH+200];
static char szUserSize[MAX_PATH+200];

static char szSearchString[MAX_SR_STRING+1];
static char szReplaceString[MAX_SR_STRING+1];

static char szScrapBuff[MAX_PATH+400];
static unsigned long dwUserSize, sdFileCount=0,total_files =0;

static struct _finddata_t sd_fdata;
static struct _finddata_t *sd = &sd_fdata;

int global_error_flag = FALSE;

// MSVC notes: 
//If changing name, manually edit "WinMain.RC"
//Project\Settings [alt F7] with RC file highlighted, ensure "exclude from build" NOT checked
/*    Ensure the classname appears in properties of the Dialogue Editor Window (see 'classname' box) */
/* CreateDialog() may also fail after editing RESOURCE.H 
Failure to open dialogue Window maye be due to a single resource item such as a progress bar
...eliminate one by one to troubleshoot
*/

/*
**  Function Prototypes
*/
long APIENTRY WndProc(HWND,UINT,UINT,LONG);
int  UpdateStatus( const char *fmt, ... );
void scan_dirs(HANDLE hConOut, char *path, char *type, unsigned long Size, BOOL doUserTask);
unsigned long my_atoi(char * str);
void RunApp(void);
BOOL GetPathFromUserDlg( HWND hWnd, char *buff );
BOOL GetFileName( HWND hWnd, char *pStrFileName );


/*
**  Global Variables
*/
HANDLE save_instance=0;
HWND hWndDialog;
HWND hWndProgressBar = NULL;
int gQuitProgMssg=0;
int gInProgress=0;
int gCancelReset=0;
int gPauseSearch = 0;
int gAbandonSearch = 0;

/* Locals... */
static HWND hWndProc;

/*------------------------------------------------------------------------------------------
**  WinMain()
*--------------------------------------------------------------------------------------------*/
int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdLine,
    int nCmdShow)
{
MSG msg;
HWND hwnd;
WNDCLASSEX wndclass;
char scrap[25];

static char  *appname = "SearchFiles";

	if(lpszCmdLine); //bummer, lpszCmdLine unused!  Silence compiler warning

	sprintf(scrap, "String Search And Replace Vers %s", version);

	save_instance=hInstance;

    if(!hPrevInstance)
	{
		wndclass.cbSize     =	sizeof(WNDCLASSEX);
        wndclass.style		=	CS_HREDRAW|CS_VREDRAW;
        wndclass.lpfnWndProc=	WndProc;
        wndclass.cbClsExtra	=	0;
        wndclass.cbWndExtra	=	DLGWINDOWEXTRA;
        wndclass.hInstance	=	hInstance;
		wndclass.hIcon		=	LoadIcon(hInstance,"IDI_ICON");
        wndclass.hCursor	=	LoadCursor(NULL,IDC_ARROW);
        wndclass.hbrBackground=	(HBRUSH) (COLOR_BTNSHADOW); // (NULL is transparent!) 
														//(7=black) (2 = deep blue)
        wndclass.lpszMenuName=	NULL;
        wndclass.lpszClassName = appname;
		wndclass.hIconSm    = NULL;
		if(!RegisterClassEx(&wndclass))
		{
			MessageBox(NULL, "Window Registration Failed!", "Error!",
				MB_ICONEXCLAMATION | MB_OK);
			return 0;
		}
    }
    hwnd=CreateDialog(hInstance,MAKEINTRESOURCE(IDD_DIALOG),0,NULL);
    if(!hwnd)
	{
        MessageBox(NULL,"Could not create window - Appname Issue?","ERROR",MB_OK|MB_ICONSTOP);
        return 1;
    }
    
	hWndDialog=hwnd;
    
	/* add new options to System (taskbar) Menu*/
    {
        HMENU hMenu;
        hMenu=GetSystemMenu(hwnd,FALSE);
        if(hMenu!=NULL)
		{
            EnableMenuItem(hMenu,SC_MAXIMIZE,MF_BYCOMMAND|MF_GRAYED);
            EnableMenuItem(hMenu,SC_SIZE,MF_BYCOMMAND|MF_GRAYED);
            AppendMenu(hMenu,MF_SEPARATOR,0,NULL);
            AppendMenu(hMenu,MF_STRING,IDM_ABOUT,"&About...");
            AppendMenu(hMenu,MF_STRING,IDC_HELP_BUTTON,"&Help...");
        }
    }
    
	// get dialog box initialized
    PostMessage(hwnd,WM_COMMAND,IDD_GETGOING,0L);

	ShowWindow(hwnd,nCmdShow);
	SetWindowText(hwnd, scrap);
	UpdateWindow(hwnd);


	// Next is Useful for repeated compiling-then-testing of one default file...commented out for release.

    while(GetMessage(&msg,NULL,0,0))
	{
		switch(msg.message)
		{
			case WM_SYSKEYDOWN:
				switch (msg.wParam) 
				{
					case VK_F4:
						DestroyWindow(hwnd);
					break;
				}
				break;

			//fall thru....
			case WM_KEYDOWN:

				switch (msg.wParam) 
				{
					/* Play with Control keys ... future feature space here */
					case 'O': //control O ?
					break;

					case VK_F12:
						MessageBox( hwnd, "With God, all things are possible.", "Info", MB_OK ); //it works
					break;

					/* I like the ESC key exit option...even tho most folks don't know it's there...
					** uncomment this section to prevent it...
					case VK_ESCAPE:					// Prevent exit on ESC key
						GetMessage(&msg,NULL,0,0);  // this will soak up the keyboard message
													// but you can overwhelm it by keeping the esc key down
					break;
					*/
				}

			//fall thru....
			default:
				if(!IsDialogMessage(hwnd,&msg)) 
				{
					TranslateMessage (&msg) ;
					DispatchMessage (&msg) ;
				}
			break;
		}
	}
    return msg.wParam;
}
char *license ={
"\nCopyright  2019 Greg Spears.\n\n"
"Permission is hereby granted, free of charge, to any person\n"
"obtaining a copy of this software and associated documentation\n"
"files (the \"Software\"), to deal in the Software without restriction,\n"
"including without limitation the rights to use, copy, modify, merge,\n"
"publish, distribute, sublicense, and/or sell copies of the Software,\n"
"and to permit persons to whom the Software is furnished to do so, \n"
"subject to the following conditions:\n"
"\n"
"The above copyright notice and this permission notice shall be\n"
"included in all copies or substantial portions of the Software.\n"
"\n"
"THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF\n"
"ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED\n"
"TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A\n"
"PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT \n"
"SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR\n"
"ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN\n"
"ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
"OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE\n"
"OR OTHER DEALINGS IN THE SOFTWARE.\n\n"};


char *help ={
"\nSearch Files and replace text\n\n"
"Enter filespecs, search and replace strings, and click RUN.\n"
"Program will search for files meeting criteria.\n\n"
"When found, the files will be modified.\n"
"NOTE: Files' date time stamps will be preserved\n\n"
"\n\n"
"Copyright  2019 Greg Spears.  Freeware...enjoy!\n\n"	};


// Then, when found, it will "do something".  That something is specified by user -
// Expectation is that an executable name (and location if not in %PATH%) will be given,
// and that executable will be allowed to do whatever it does to the found file.
//
// It should work for DOS commands like "del" too.
// 
//
// Could give a command like this:
//
// copy /b/v %1 c:\temp\ >> c:\temp\logging.log
// 
// ...and %1 is replaced with the found file






/*------------------------------------------------------------------------------------

WndProc(HWND hwnd,UINT message,UINT wParam,LONG lParam)

  This is a dialog box procedure but is also the main window.
  The dialgue-box-as-main-window is a great UI...lean, aesthetic.
--------------------------------------------------------------------------------------*/
long APIENTRY WndProc(HWND hWnd, UINT message,UINT wParam, LONG lParam)
{
char sz[200];
static HANDLE hinstIE;
int bsuccess;

	hWndProc = hWnd;

    switch(message)
	{
    case WM_SYSCOMMAND:
        switch(wParam)
		{
			case IDM_ABOUT:
				sprintf(sz, 
				"Search Files\n"
				"Version %s \n"
				"Copyright  2010 Greg Spears\n\n",	version);
				MessageBox(hWndDialog,sz, "LogFile About", MB_OK);
				SetFocus(GetDlgItem(hWnd,IDD_RUN_BUTTON));
			return 1;
        
			case IDC_HELP_BUTTON:
				PostMessage(hWnd,WM_COMMAND,IDC_HELP_BUTTON, 0); 
			return 1;
        }
    break;

	case WM_COMMAND:
        switch(wParam)
		{
			case IDD_GETGOING:

				gQuitProgMssg=0;

				//MessageBox(NULL, "Entered API", "Info", MB_OK );
#if 1
				hWndProgressBar = GetDlgItem(hWnd,IDC_PROGRESS_BAR);
				SendMessage(hWndProgressBar, PBM_SETRANGE, (WPARAM)0,  MAKELPARAM(0, PROGRESS_GRANULARITY));      
				SendMessage(hWndProgressBar, PBM_SETSTEP, (WPARAM)1,  (LPARAM)0);      
				SendMessage(hWndProgressBar, PBM_SETBARCOLOR, (WPARAM)0, (LPARAM)RGB(0,255,0));
				SendMessage(hWndProgressBar, PBM_SETPOS, (WPARAM)0,  (LPARAM)0);      
				SendMessage(hWnd, WM_COMMAND, (WPARAM)(IDD_SET_WAITING_FACE), (LPARAM)0);
#endif
				/* fall thru 1st time ...*/
			case IDD_SET_DEFAULTS: 
				strcpy(szUserPath, "C:\\");
				SendMessage(GetDlgItem(hWnd,IDD_PATH),WM_SETTEXT,0,(LONG)(LPSTR)szUserPath);

				strcpy(szUserType, "*.*");
				SendMessage(GetDlgItem(hWnd,IDD_FILE_TYPE),WM_SETTEXT,0,(LONG)(LPSTR)szUserType);
			
				SendMessage(GetDlgItem(hWnd,IDD_FILE_SIZE),WM_SETTEXT,0,(LONG)(LPSTR)"0");
				SendMessage(GetDlgItem(hWnd,IDD_DELAY_MSECS),WM_SETTEXT,0,(LONG)(LPSTR)"0");
	
				global_error_flag = FALSE;

				UpdateStatus("Idling....");
				
			return 1; 

			case IDD_GETVARS:
				SendMessage(GetDlgItem(hWnd,IDD_PATH),WM_GETTEXT, sizeof(szUserPath)-1,(LPARAM)szUserPath);
				SendMessage(GetDlgItem(hWnd,IDD_FILE_TYPE),WM_GETTEXT, sizeof(szUserType)-1,(LPARAM)szUserType);
				*szUserSize = '\0';
				SendMessage(GetDlgItem(hWnd,IDD_FILE_SIZE),WM_GETTEXT, sizeof(szUserSize)-1,(LPARAM)szUserSize);
				dwUserSize = my_atoi(szUserSize);
				SendMessage(GetDlgItem(hWnd,IDD_SEARCH_STRING_BOX),WM_GETTEXT,MAX_SR_STRING,(LPARAM)szSearchString);
				SendMessage(GetDlgItem(hWnd,IDD_REPLACE_STRING_BOX),WM_GETTEXT,MAX_SR_STRING,(LPARAM)szReplaceString);

			break;

			case IDD_SET_WAITING_FACE:		
				//SendMessage(hWndProgressBar, PBM_SETPOS, (WPARAM)(0), (LPARAM)0);
				UpdateStatus("Waiting ...");
				//GetModuleFileName(NULL, sz, MAX_PATH);
				//MessageBox(NULL, sz, "Info", MB_OK );
			return 1;

			case IDD_SET_INIT_FACE:		
				//SendMessage(hWndProgressBar, PBM_SETPOS, (WPARAM)(0), (LPARAM)0);
			return 1;

			case IDC_HELP_BUTTON: 
				MessageBox(hWnd, help, "Help", MB_OK );
			break;

			case IDC_LICENSE_BUTTON:
				MessageBox(hWnd, license, "License", MB_OK );
			return 1;

			case IDC_BROWSE_SEARCHPATH_BUTTON:
				bsuccess= GetPathFromUserDlg(hWnd,  szUserPath);
				if(!bsuccess)
				{
					//MessageBox(hWnd, "Browse Folders operation failed!", "ERROR", MB_ICONEXCLAMATION  );
					return 0;
				}
				/* Print path into GUI Path box */
				SendMessage(GetDlgItem(hWnd,IDD_PATH),WM_SETTEXT,0,(LONG)(LPSTR)szUserPath);
			return 1; 

			case IDC_PAUSE:
				if(gInProgress)
				{
					gPauseSearch = 1;
					UpdateStatus("Paused....");
				}
			return 1;

			case IDC_CANCEL_RESET:
				gCancelReset = 1;
				global_error_flag = FALSE;
				gInProgress = gPauseSearch = 0;
				gAbandonSearch = 1;
				UpdateStatus("Idling....");
				SendMessage(hWndProgressBar, PBM_SETPOS, (WPARAM)0,  (LPARAM)0); 
			return 1;


			case IDD_RUN_BUTTON:

				gPauseSearch = 0;
				gCancelReset = 0;
				gAbandonSearch  = 0;

				UpdateStatus("In Progress...."); //
				//SendMessage(GetDlgItem(hWndDialog,IDD_STATUS_BOX),WM_SETTEXT,0,(LONG)(LPSTR)"In Progress");

				if(!gInProgress)
				{
					
					SendMessage(hWnd,WM_COMMAND, IDD_GETVARS,0);
					SendMessage(hWndProgressBar, PBM_SETPOS, (WPARAM)(0), (LPARAM)0);
					/* standard initializations... */
			
					/* Call program */
					RunApp();
				}
			return 1;


			case IDCANCEL:
			case IDCLOSE:
				gPauseSearch = 0;
				gAbandonSearch = 1;
				gQuitProgMssg=1;
				PostMessage(hWnd,WM_SYSCOMMAND,SC_CLOSE,0L);
			return 1;

		}
        break;
    
		case WM_DESTROY:
			gQuitProgMssg=1;
			PostQuitMessage(0);
        return 0;
    }
    return DefWindowProc(hWnd,message,wParam,lParam);
}

 /*----------------------------------------------------

  is_num()
 ----------------------------------------------------*/
int is_num(int ch)
{
	if(ch >= '0' && ch <= '9')
		return 1;
	return 0;
}



/*----------------------------------------------------

  my_atoi()

  Inbound sttring may have varied formats:
  1,000,000
  1,000 kb
  1,000 Mb
  22987
----------------------------------------------------*/
unsigned long my_atoi(char * pStr)
{
char workBuff[50], *pWB = workBuff;
unsigned long multiplier =1, result =0;

	if(!pStr  ||  strlen(pStr) == 0)
		return 0;

	strcpy(workBuff, pStr);
	strupr(workBuff);

	/* Deal with KB and MB */
	if(strstr(workBuff, "KB"))
		multiplier = 1024L;
	if(strstr(workBuff, "MB"))
		multiplier = 1024L*1024L;

	/* Now remove commas and alphas....*/
	while(*pStr)
	{
		if(is_num(*pStr))
			*pWB++ = *pStr;
		pStr++;
	}
	*pWB = '\0';  //cap it

	result = atol(workBuff);
	return result * multiplier;
}


/*----------------------------------------------------

  _delay()

  
----------------------------------------------------*/
void _delay(long ms)
{
long loops = (ms+9)/10;

	if(loops < 1)
		return;

	while(loops-- && !gQuitProgMssg && !gCancelReset)
	{
		SpinTheMessageLoop(NULL);
		Sleep(10);
		SpinTheMessageLoop(NULL);
	}
}

 
 /*----------------------------------------------------

  UpdateStatus()

  Status update specific to this application
 ----------------------------------------------------*/
int UpdateStatus( const char *fmt, ... )
{
va_list  argptr;          /* Argument list pointer    */
char Str[200];            /* Buffer to build string into   */
char sBuff[200];
int resultGM=50;

    va_start( argptr, fmt );         /* Initialize va_ functions */
    vsprintf( Str, fmt, argptr );   /* prints string to buffer  */
    va_end( argptr );              /* Close va_ functions      */
    
	//while(resultGM --)
	SendMessage(GetDlgItem(hWndDialog,IDD_STATUS_BOX),WM_SETTEXT,0,(LONG)(LPSTR)Str);
	
	//Sleep(500);
   	*sBuff = '\0';
	do{

		resultGM=SendMessage(GetDlgItem(hWndDialog,IDD_STATUS_BOX),WM_GETTEXT,0,(LONG)(LPSTR)sBuff);
		if(!strcmp(sBuff, Str))
			break;
		if(resultGM == -1)
			break;
		//SendMessage(GetDlgItem(hWndDialog,IDD_STATUS_BOX),WM_SETTEXT,0,(LONG)(LPSTR)sBuff);
	}while(0);

	return 0; //strlen(Str);
}


/*-----------------------------------------------------------------------

  qmatch()     

  
*-----------------------------------------------------------------------*/
int qmatch(struct _finddata_t *qsd, char *pType, unsigned long Size)
{
char *pFileFoundType, *pFileParamType = strrchr( pType,  '.' );

	if(qsd->size < Size) /* Size no match ....then nothing else matters */
		return FALSE;

	if(!strcmp(pType, "*.*")) /* if all types qualified, good */
		return TRUE;

	pFileFoundType = strrchr( qsd->name, '.' );
	if(pFileFoundType && pFileParamType)
		if(!stricmp(pFileFoundType,  pFileParamType))
			return TRUE;

	return FALSE;
}


 
 /*-----------------------------------------------------------------------

  scan_dirs()     

  Design note: go easy on the stack ...this is recursive

  This function will add the trailing slash on path if needed.

*-----------------------------------------------------------------------*/
static void scan_dirs(HANDLE hWin, char *pPath, char *pType, unsigned long Size, BOOL doUserTask)
{
char  *wholepath = malloc(MAX_PATH+200);
long handle, match = 0;
long count=0;


	if( (total_files %10 ) == 0)
	{
		if(!doUserTask)
			UpdateStatus("Scanning Directories...please wait...");
		else
			UpdateStatus("Scanning Directories...");
	}

	SpinTheMessageLoop(NULL);

	if(gAbandonSearch)
	{
		free(wholepath);
		return;
	}
    if( wholepath ) 
    {
        memset(sd, 0, sizeof(sd));
        dir_strcat(wholepath, pPath, "*.*");
		handle = _findfirst(wholepath,  sd);
		if(handle != -1)
        {
            do
            {
				SpinTheMessageLoop(NULL);
				if(gAbandonSearch)
					break;

				/*Enable pause no matter what kind of Op*/
				while(gPauseSearch && !gAbandonSearch)
				{
					_delay(10);
				}

				if(gAbandonSearch)
					break;

                if(sd->attrib & _A_SUBDIR) 
                {
					if(sd->name[0] != '.')
					{
						dir_strcat(wholepath, pPath, sd->name);
						if(LAST_CHAR(wholepath) != '\\')
							strcat(wholepath, "\\");
						scan_dirs(hWin, wholepath, pType, Size, doUserTask);   /* recursive call */
					}
                }
				else  /* This is a file */
				{
					match = qmatch(sd, pType, Size);
					if(match)
						sdFileCount++;
					
					SpinTheMessageLoop(NULL);
					//Sleep(1);

					if(doUserTask && match)
					{
					long bar_pos;

						/* Update status (I prefer a ProgressBar ) */
						if(!total_files)
							total_files = 1;

						UpdateStatus("Progress: %lu of %lu files. (%0.0f%%)", 
						     sdFileCount, total_files, (double)((double)sdFileCount * 100.0 / (double)total_files)) ;
					
						/* Update Progress Bar */
						bar_pos = (((sdFileCount+1L)* PROGRESS_GRANULARITY)/total_files);
						SendMessage(hWndProgressBar, PBM_SETPOS, (WPARAM)(bar_pos), (LPARAM)0);

						/*Prep for run command */
						if(!gAbandonSearch)
						{
						int success;

							dir_strcat(wholepath, pPath, sd->name);

							//MessageBox(hWndDialog,szExecCmdBuff,"INFO - See Run Cmd", MB_ICONINFORMATION);

							/* And run it! */

							success = update_file(wholepath, szSearchString, szReplaceString);
							
						}

						/* See if pause or sleep on Match*/
						*szScrapBuff = '\0';
						SendMessage(GetDlgItem(hWndDialog,IDD_DELAY_MSECS),WM_GETTEXT, sizeof(szScrapBuff)-1,(LPARAM)szScrapBuff);
						_delay(atol(szScrapBuff));

					}// (doUserTask && match)
				}//   is a file 

			
			}while(!_findnext(handle, sd));
        }
		_findclose(handle);
        free(wholepath);
    }
}




/*----------------------------------------------------------------------

  SpinTheMessageLoop()

  Ck for Windows messages during long ops, such as file read-write that we do.
  You can tell when windows programmers forget this...when the running app
  seems to suck all resources & permit nothing else to happen until it's done.
  
*-------------------------------------------------------------------------*/
BOOL SpinTheMessageLoop(HWND hWnd)
{
MSG msg;

	if(hWnd); //unused

	if(PeekMessage((LPMSG)&msg,NULL,0,0,PM_REMOVE)) //hWnd or NULL
	{
		TranslateMessage (&msg);
		DispatchMessage (&msg);
	}
	return TRUE;
}


/*----------------------------------------------------
  extract_path_and_filename()
  
	Extract path and filename without modifying inbound string

 ----------------------------------------------------*/
void extract_path_and_filename(char *pszIn, char *pszPath, char *pszFname)
{
char  *ptr;

	strcpy(pszPath, pszIn);

	ptr=pszPath + strlen( pszPath );
	while(*ptr != '\\' && *ptr != '/' && *ptr != ':' && ptr>pszPath)
		ptr--;
	strcpy(pszFname,ptr+1); //copy part just past the '\\'  

	*(ptr+1) ='\0'; //filename gone! (string now ends with trailing slash '\'
}



/*----------------------------------------------------

  RunApp()
 ----------------------------------------------------*/
void RunApp(void)
{
char szBuff[1700];         /* Buffer to build string into   */

	if(gInProgress)
		return;
	gInProgress=1;
	
	UpdateStatus("Scanning Directories...");
	//Sleep(5000);

	/* Get the file count...we'll want this to tell user about progress (done vs. sdFileCount) */
	sdFileCount =0 ;  //global
	scan_dirs(NULL, szUserPath, szUserType, dwUserSize, 0);
	total_files =  sdFileCount;
	
	UpdateStatus("Matching files found :  %lu", total_files );
	if(!total_files)
	{
		gInProgress=0;
		return;
	}

	/* ----- Now call scan_dirs() with actual work application enabled ------ */
	sdFileCount =0 ;  //global
	scan_dirs(NULL, szUserPath, szUserType, dwUserSize, 1);

	if(global_error_flag)
	{
		sprintf(szBuff, "ERRORS detected.  Please check logging file '%s'", dbugFname);
		MessageBox(NULL, szBuff, "ERROR", MB_ICONEXCLAMATION );
	}
	global_error_flag = 0;

	//if(!gQuitProgMssg)	UpdateStatus("Progress: %lu%%", 100) ;
	gInProgress=0;
	/* ----- */


	/* ----- */

	/* ----- */

}



/*--------------------------------------------------------
http://support.microsoft.com/kb/152457

Explorer [/n] [/e] [(,)/root,<object>] [/select,<object>]

/n                Opens a new single-pane window for the default
                  selection. This is usually the root of the drive Windows
                   is installed on. If the window is already open, a
                  duplicate opens.

/e                Opens Windows Explorer in its default view.

/root,<object>    Opens a window view of the specified object.


/select,<object>  Opens a window view with the specified folder, file or
                  application selected.

Examples:

   Example 1:     Explorer /select,C:\TestDir\TestApp.exe

      Opens a window view with TestApp selected.

   Example 2:  Explorer /e,/root,C:\TestDir\TestApp.exe

      This opens Explorer with C: expanded and TestApp selected.

   Example 3:  Explorer /root,\\TestSvr\TestShare

      Opens a window view of the specified share.

   Example 4:  Explorer /root,\\TestSvr\TestShare,select,TestApp.exe

      Opens a window view of the specified share with TestApp selected.

----------------------------------------------------------------*/