#include "STR_OPS.H"
#include <string.h>
#include <stdio.h>
#include <windows.h>

//#define TRUE 1
//#define FALSE 0


int str_drive_chr(const char *s)
{
    return !!strchr((s), ':');
}

int str_slash_chr(const char *s)
{
    return ((strchr((s),'\\')) || (strchr((s),'/')));
}

int str_path_chr(const char *s)
{
   return  (str_slash_chr(s) || str_drive_chr(s));
}


int has_wild(char *str)
{
int i=strlen(str);

    do{
        i--;
        switch(str[i])
        {
            case '?':
            case '*':
            return TRUE;
            default:
            break;
        }
    }while(i > -1);
    return FALSE;

}


#if 0
void build_string_from_wild(char *targ, const char *str, const char *pat)
{
    for(;;)
    {
        switch(*pat)
        {
            case '\0':
                if(*(targ-1)=='.')
                    targ--;
                *targ = '\0';
            return;

            case '*' :
                // a _single_ '*' matches the entire string....
                while(*str && ( (! *(pat+1)) ||  *str != '.'))
                {
                    *targ++ = *str++;
                }
                pat++;
                while(*pat && (*pat != '.'))
                    pat++;
            break;

            case '?' :
                if(*str && *str != '.')
                    *targ++ = *str++;
                pat++;
            break;

            case '.':
                //scan to next '.' in str, if rqr'd
                while(*str && (*str != '.'))
                {
                    str++;
                }
                // *str must be 0 or '.' now...
                *targ++ = '.';
                if(*str)
                    str++;
                pat++;
            break;

            default: // a letter or number in pattern?
                     //use it directly
                *targ++ = *pat++;
                if(*str && *str != '.')
                    str++; //str forfeits this position
            break;
        }
    }
}

/*
Rules:
         1.) * and *.*  match any and all
         2.) ? must match a single char, and that char must not be a '.'
                - only '.' can match a '.', unless part of *.*

*/
int patimatch(const char *pat, const char *str)
{

    if(!stricmp(pat,"*") || !stricmp(pat,"*.*"))
        return TRUE;

    while(*str)
    {
        switch (*pat)
        {
            case '\0':
            return !(*str);    //if *str also 0, return true

            case '*' :
                while(*str && *str != '.')
                {
                    str++;
                }
                pat++;
                while(*pat && (*pat != '.'))
                    pat++;
            break;

            case '?' :
                if(*str == '.')
                {
                    return FALSE;
                }
                str++;
                pat++;
            break;

            default:
                if(toupper(*pat) != toupper(*str))
                {
                    return FALSE;
                }
                str++;
                pat++;
            break;
        }
    }
    return !(*pat);
}

//----------------------------------------------------------------------
//
//  append_slash_to_match()
//
//  simple string function -- appends or deletes last slash in a path
//   to assist with determining if 2 paths match
//
//----------------------------------------------------------------------
void append_slash_to_match(char *p1, const char *p2)
{
    if(LAST_CHAR(p1)== '\\'  && LAST_CHAR(p2) != '\\')
        LAST_CHAR(p1) = '\0';

    if(LAST_CHAR(p1) != '\\' && LAST_CHAR(p2) == '\\')
        strcat(p1, "\\");
}


//----------------------------------------------------------------------
//
//  HasValidDrive()
//
// params:
//
//      char *name - pathname to validate
//
// Note: Name is currently only checked for a valid drive
// Caution: if no drive in string, still returns true - current
//           drive is assumed, thus current drive assumed valid - see?
// returns TRUE/FALSE
//
//----------------------------------------------------------------------

int HasValidDrive(const char *name)
{
    if(str_drive_chr(name))
    {
        if(HaveDrive(name[0]))
            return TRUE;
        return FALSE;
    }
    return TRUE;
}

void get_DOS_fname(char *pDOS_name, char *pWin_name)
{

	strcpy(pDOS_name, "MAIN.C");

#if 0
int cur_drive=-10;
char path[_MAX_PATH+1];
char old_dir[_MAX_PATH+1];
struct lf_find_t f;

    if(!long_filenames)
        strcpy(pDOS_name,pWin_name);

    if(HasValidDrive(pWin_name))
    {
        cur_drive=getdisk();
        setdisk(toupper(pWin_name[0])-'A');
    }
    os_getcwd(old_dir, _MAX_PATH);
    extract_path(path, pWin_name);
    os_chdir(path);
    getcwd(path, _MAX_PATH);
    memset(&f, 0, sizeof(f));
    _findfirst(pWin_name, 0xFF, &f);
    if(f.short_name[0])
        dir_strcat(pDOS_name, path, f.short_name);
    else
        dir_strcat(pDOS_name, path, get_ptr_to_fn_in_path(pWin_name));
    if(cur_drive !=-10)
        setdisk(cur_drive);
    os_chdir(old_dir);
#endif
}


#endif


#define DOTS          3
#define FIRST_3_CHARS 3

/**************************************
**
** NortonDirTitle()   (no padding)
**
***************************************/
void NortonDirTitle(char *dest, const char *src, int MaxLen)
{
int len =strlen(src), offs = MaxLen>>1;

    if(MaxLen<1)
    {
        strcpy(dest,"err!");
        return;
    }

    if(MaxLen <5)
    {
        while(MaxLen--)
            *dest++ = *src++;
        *dest=0;
        return;
    }
    if(len <= MaxLen )
    {
        strcpy(dest, src);
        return;
    }
    // At this point, ...
    // we know max_len > 0
    // we know src is longer than max_len
    // we assume dest is a buffer of max_len

    strncpy(dest,src,offs);      //copy 1st portion of src string to dest
    strcpy(&dest[offs],"...");   //add the ... to dest string
    offs=len-(MaxLen-strlen(dest)); //want last portion of src string  in dest
    strcat(dest,&src[offs]);
    if(strlen(dest) > (unsigned)MaxLen)
        strcpy(dest, "oflow!");

}
/**************************************
**
** NortonDirTitlePad()
**

[F:\MYPATH\BLAH][ ARJ MODE ][ DATE ]ͻ
                                              

***************************************/
void NortonDirTitlePad(char *dest, const char *src, int MaxLen, int fsort)
{
int len;
char *sz_sort = "[ TYPE ]";

    strncpy(dest, "[ ", 2);
    NortonDirTitle(&dest[2], src, MaxLen-(8+4));
    len=strlen(dest);
    dest[len]=' ';
    dest[len+1]=']';

    memset(&dest[len+2], ' ',  MaxLen-(len+2));

    strcpy(&dest[MaxLen-8], sz_sort);
}

/*********************************************
**
** dir_strcat()
**
** Cat's the next lower dirname with the
** current dirname, splicing the '\' as rqr'd
**
*********************************************/
void dir_strcat(char *dest, const char *upperDir, const char *lowerDir)
{
    if(IS_SLASH_TOKEN(LAST_CHAR(upperDir)))
         sprintf(dest,"%s%s",  upperDir,lowerDir);
    else sprintf(dest,"%s\\%s",upperDir,lowerDir);
}


//----------------------------------------------------------------------
//
// ExtractFName()
//
// Extracts filename from a path String
//
//----------------------------------------------------------------------
int ExtractFName(char *fName, const char *PathAndFileName)
{
char *ptr;

    if(fName)
        *fName=0;

    ptr=get_ptr_to_fn_in_path((char *)PathAndFileName);
    if(fName && *ptr)
        strcpy(fName, ptr);
    return strlen(ptr);
}

//----------------------------------------------------------------------
//
//  get_ptr_to_fn_in_path()
//
//  params:
//
//      char *path of a file name
//
// Note: param is assumed to be a path with a file name at end!:
//
//           G:\MYDIR\NEWSTUFF\PROJECTS\FILENAME.fil
//
//
//       If no filename:
//        will return a pointer to trailing (last) directory or the
//        trailing '\0' in the string, depending which was given:
//     G:\MYDIR\NEWSTUFF\PROJECTS  or  G:\MYDIR\NEWSTUFF\PROJECTS'\'
//
//       If no path:
//        returns a pointer to the input param
//        (FILENAME.fil)
//
//----------------------------------------------------------------------
char *get_ptr_to_fn_in_path(char *path)
{
char *ptr;

	ptr = strrchr(path, '\\');
    if(!ptr)
    {
		ptr = strrchr(path, '/' );
        if(! ptr )  // unix style?
        {
            ptr = strchr(path, ':' );  //whoops --yea, don't forget this one
        }
    }

    if(!ptr) //if no path token...
        return path;

    return (ptr +1);  // else, return ptr to next char in string - the name
}

/**********************************************************
**
** strcpy_low_name()
**
**
**  This func gets the "lowest" or deepest directory name
**  from a directory string (devoid of path tokens and slashes).
**  In a string like so:
**
**  G:\MYDIR\NEWSTUFF\PROJECTS  or  G:\MYDIR\NEWSTUFF\PROJECTS\
**
**  ... the "lowest" dir is 'PROJECTS'
**
**  Assumes a path name without a file!
**
**********************************************************/
int strcpy_low_name(char *dest, const char *src)
{
char buff[MAX_PATH+1];

    *dest=0;
    if(src)
    {
        strcpy(buff,src);
        //kill the last slash is one exists
        if(IS_SLASH_TOKEN(LAST_CHAR(buff)))
            LAST_CHAR(buff) = 0;
        strcpy(dest,get_ptr_to_fn_in_path(buff));
        //SysInfo("%s from %s",dest,src);
        return TRUE;
    }
    return FALSE;
}

//-----------------------------------------------------------------------
//
//  strcpy_hi_name()       (GetParent())
//
//  This func gets the "high name" or path above the deepest nested dir
//  from a directory string.
//
//  Or, it kind of strips the lowest dir from the path, where...
//
//  G:\MYDIR\NEWSTUFF\PROJECTS  or  G:\MYDIR\NEWSTUFF\PROJECTS'\'
//
//  ... the "hi name" is "G:\MYDIR\NEWSTUFF"
//
//  ...and will be copied to *dest
//
//
//-----------------------------------------------------------------------
int strcpy_hi_name(char *dest, const char *src)
{
register len;

    *dest=0;
    if(!src)
        return 0;
    len=strlen(src)-1;   //src[i-1] *should* = '\\'

    //scr[i] is now 1 less than '\\' or at end of string
    while(len--)
    {         
        if(IS_SLASH_TOKEN(src[len]))  //Break! We've got it....
        {
            strncpy(dest,src,len);
            dest[len] = '\0'; //gotta cap it when using strncpy()
            return(len);
        }
    }
    strcpy(dest,src);
    return strlen(dest);
}

//----------------------------------------------------------------------
//
//  char *stristr()
//
//   returns pointer to first occurrance of substring in string
//    NULL if not found
//
// params:
//
//      str - string to search
//      pattern - string to search for
//
// This optimized version is twice as fast as competitor... about 48
//  bytes more expensive in code.
//
// Also discovered that tolower() is faster than toupper() in Turbo C
//  and Watcom
//----------------------------------------------------------------------
#if 1
char *stristr(const char *str, const char *pattern)
{
int s,p;
const char *pat=&pattern[1];
char firstch= (char)tolower(*pattern);

    do {
        // Speed optimization: scan string for a match on 1st character
        while(!!(s = tolower(*str)))  //I'm unsure about this now
        {
            if(s != firstch)
            {
                str++;
                continue;
            }
            break;
        }

        if(s)
        {
            // We've found the beginning of a match, scan for continued match
            str++;
            pat=&pattern[1];
            do{
                if(!*pat)  //have we reached the end of search string?
                    return (char *)str-(strlen(pattern)); //Y: and we've been thru whole string - a match
                s = tolower(*str++);
                p = tolower(*pat++);
            } while(s==p);
            str--;
        }
    }while(s);

    return(NULL);
}

#endif
/*********************************************************************
**
** StripSpace()
**
** If an fgets() or cgets() string has trailing
** whitespace, CR or LF,  remove it.
**
** Else, leave it alone!
**
***********************************************************************/
void StripSpace(char *str)
{
int i=strlen(str)-1; //-1 important!
    do{
        if((str[i]==13) || (str[i]==10) || (str[i]==32))
            str[i] = '\0';
        else
            break;
    }while(i--);
}


void extract_path(char *dest, char *path)
{
register    i;

    strcpy(dest,path);
    i=strlen(dest);
    while(i--)
    {
        if(IS_PATH_TOKEN(dest[i]))
            break;
        dest[i]='\0';    //cap it
    }
}

/***************************************************************
**
** StripName()
**
** Modifies string, so make copy before calling
** Strip filename from path, if filename.
**
** Warn/note!: If no terminating "\\", lowest subdir is treated as
**        filename and stripped!!!!
**
***************************************************************/
void StripName(char *str)
{
int len=strlen(str);

    if((!IS_PATH_TOKEN(LAST_CHAR(str)))  && (len > 0) )
    {
       while(len--)
       {
           if(IS_PATH_TOKEN(str[len]))
               break;
           str[len] = '\0';
       }
    }
}





/***********************************************************************
**
** GetHomeDir()
**
** Gets Program's Home Directory into string "HomeDir[]"
**
**  DWORD WINAPI GetModuleFileName(  HMODULE hModule,  LPTSTR lpFilename,  DWORD nSize);
    
    hModule: [in] Handle to the module whose path is being requested. If this parameter is NULL, GetModuleFileName retrieves the path of the executable file of the current process. 
    
    lpFilename: [out] Pointer to a buffer that receives a null-terminated string that specifies the fully-qualified path of the module. If the length of the path exceeds the size that the nSize parameter specifies, the function succeeds, and the string is truncated to nSize characters and cannot be null terminated.
    The string returned will use the same format that was specified when the module was loaded. Therefore, the path can be a long or short file name, and can use the prefix "\\?\". For more information, see Naming a File.
    
    nSize [in] Size of the lpFilename buffer, in TCHARs. 
    
    Note: the exe name WILL be in the path!
    
    Return Values
    If the function succeeds, the return value is the length of the string that is copied to the buffer, in TCHARs. 
    If the buffer is too small to hold the module name, the string is truncated to nSize, the function returns 
    nSize, and the function sets the last error to ERROR_INSUFFICIENT_BUFFER.
    If the function fails, the return value is 0 (zero). To get extended error information, call GetLastError.
    
***********************************************************************/
const char *GetHomeDir(void)
{
int    iii;
static int  firstTime   =   TRUE;  /* We'll only go thru all the motions */
static char homeDir[MAX_PATH+100];   /* once - optimization! (Thanx Warren) */

    if(firstTime)
    {
        homeDir[0]='\0';
        GetModuleFileName(NULL, homeDir, sizeof(homeDir)-1);   //note: the exe name WILL be in the path!
        firstTime=FALSE;
        iii=strlen(homeDir);
        while(iii--)
        {
            if(homeDir[iii]=='\\')
                break;
            homeDir[iii]='\0';    //strip exe name it
        }
    }
    return homeDir;
}




//#define TEST
#ifdef TEST

void main(int argc, char *argv[])
{
char temp[128];
char test[128]="";
int len;
char *ptr;

    printf("\nHomeDir = %s\n",GetHomeDir(argv[0]));
    printf("\nHomeDir = %s\n",GetHomeDir(argv[0]));
    printf("\nHomeDir = %s\n",GetHomeDir(argv[0]));
    printf("\nHomeDir = %s\n",GetHomeDir(argv[0]));

    len = ExtractFName(temp,argv[0]);
    printf("\nProgram Filename = %s  len: %d\n",temp,len);
    len = ExtractFName(temp,"");
    printf("\nProgram Filename = %s  len: %d\n",temp,len);
    len = ExtractFName(temp,test);
    printf("\nProgram Filename = %s  len: %d\n",temp,len);

    len = ExtractFName(temp,argv[0]);
    len = ExtractFName(NULL,temp);
    printf("\nProgram Filename = %s  len: %d\n",temp,len);

    len = ExtractFName(NULL,argv[0]);
    printf("\nProgram Filename = %s  len: %d\n",temp,len);

    printf("\n\n");


    ptr = "C:";
    len = ExtractFName(NULL,ptr);
    printf("Orig Name: %s Extname = %s  len: %d\n",ptr,NULL,len);

    ptr = "C:\\";
    len = ExtractFName(temp,ptr);
    printf("Orig Name: %s Extname = %s  len: %d\n",ptr,temp,len);
    printf("%s %s a valid filename\n",ptr,isValidFileName(ptr)?"IS":"IS NOT");

    ptr = "C:\\GOMER\\SUCK\\";
    len = ExtractFName(temp,ptr);
    printf("Orig Name: %s Extname = %s  len: %d\n",ptr,temp,len);
    printf("%s %s a valid filename\n",ptr,isValidFileName(ptr)?"IS":"IS NOT");

    ptr = "C:\\GOMER\\SUCK\\BIG.BAT";
    len = ExtractFName(temp,ptr);
    printf("Orig Name: %s Extname = %s  len: %d\n",ptr,temp,len);
    printf("%s %s a valid filename\n",ptr,isValidFileName(ptr)?"IS":"IS NOT");

    ptr = "C:BIG.BAT";
    len = ExtractFName(temp,ptr);
    printf("Orig Name: %s Extname = %s  len: %d\n",ptr,temp,len);
    printf("%s %s a valid filename\n",ptr,isValidFileName(ptr)?"IS":"IS NOT");

    ptr = "GOMER\\SUCK\\BIG.BAT";
    len = ExtractFName(temp,ptr);
    printf("\nOrig Name: %s Extname = %s  len: %d\n",ptr,temp,len);
    printf("%s %s a valid filename\n",ptr,isValidFileName(ptr)?"IS":"IS NOT");

    ptr = "\\BIG.BAT";
    len = ExtractFName(temp,ptr);
    printf("Orig Name: %s Extname = %s  len: %d\n",ptr,temp,len);
    printf("%s %s a valid filename\n",ptr,isValidFileName(ptr)?"IS":"IS NOT");

    ptr = "BIG.BAT";
    len = ExtractFName(temp,ptr);
    printf("Orig Name: %s Extname = %s  len: %d\n",ptr,temp,len);
    printf("%s %s a valid filename\n",ptr,isValidFileName(ptr)?"IS":"IS NOT");

    ptr = "B";
    len = ExtractFName(temp,ptr);
    printf("Orig Name: %s Extname = %s  len: %d\n",ptr,temp,len);
    printf("%s %s a valid filename\n",ptr,isValidFileName(ptr)?"IS":"IS NOT");

    ptr = "";
    len = ExtractFName(temp,ptr);
    printf("Orig Name: %s Extname = %s  len: %d\n",ptr,temp,len);
    printf("%s %s a valid filename\n",ptr,isValidFileName(ptr)?"IS":"IS NOT");

    ptr = "C:/GOMER/SUCK/BIG.BAT";
    len = ExtractFName(temp,ptr);
    printf("Orig Name: %s Extname = %s  len: %d\n",ptr,temp,len);
    printf("%s %s a valid filename\n",ptr,isValidFileName(ptr)?"IS":"IS NOT");

    ptr=argv[0];
    printf("%s %s a valid filename\n",ptr,isValidFileName(ptr)?"IS":"IS NOT");

    ptr="g.oooo";
    printf("%s %s a valid filename\n",ptr,isValidFileName(ptr)?"IS":"IS NOT");

    ptr="12345678.900";
    printf("%s %s a valid filename\n",ptr,isValidFileName(ptr)?"IS":"IS NOT");

    ptr="123.12345";
    printf("%s %s a valid filename\n",ptr,isValidFileName(ptr)?"IS":"IS NOT");

    ptr="123456789.12345";
    printf("%s %s a valid filename\n",ptr,isValidFileName(ptr)?"IS":"IS NOT");


    ptr="123456789.15";
    printf("%s %s a valid filename\n",ptr,isValidFileName(ptr)?"IS":"IS NOT");

    ptr="12345678.12";
    printf("%s %s a valid filename\n",ptr,isValidFileName(ptr)?"IS":"IS NOT");
    ptr="12345678.1234";
    printf("%s %s a valid filename\n",ptr,isValidFileName(ptr)?"IS":"IS NOT");

    ptr="1234567.1234";
    printf("%s %s a valid filename\n",ptr,isValidFileName(ptr)?"IS":"IS NOT");

    ptr="1234567.12";
    printf("%s %s a valid filename\n",ptr,isValidFileName(ptr)?"IS":"IS NOT");
}

#endif

